Index: drivers/scsi/sg.c
===================================================================
--- drivers/scsi/sg.c	(.../trunk/cernlinux)	(revision 17)
+++ drivers/scsi/sg.c	(.../branches/cernlinux/ibm3590_load_display_cmd)	(revision 17)
@@ -562,6 +562,14 @@
 	if ((opcode >= 0xc0) && old_hdr.twelve_byte)
             cmd_size = 12;
     }
+
+    /* Support IBM Load Display command on IBM3590.
+     * Command opcode is 0xC0 and CDB len is 6 instead of 10.
+     * Originally by Fabien Collin. */
+    if ((opcode == 0xc0) && (old_hdr.twelve_byte == 0)) {
+	cmd_size = 6;
+    }
+
     SCSI_LOG_TIMEOUT(4, printk("sg_write:   scsi opcode=0x%02x, cmd_size=%d\n",
                                (int)opcode, cmd_size));
 /* Determine buffer size.  */
